(function () {
    'use strict';
    var designer = GC.Spread.Sheets.Designer;
    designer.shapeStyleTemplates = {
        autoShapeStyle: [
            {
                baseStyle: {
                    borderWidth: 1,
                    backgroundColor: 'white',
                    color: 'black'
                },
                shapes: [
                    {
                        borderColor: 'rgb(0,0,0)',
                    },
                    {
                        borderColor: 'rgb(68,114,196)',
                    },
                    {
                        borderColor: 'rgb(237,125,49)',
                    },
                    {
                        borderColor: 'rgb(165,165,165)',
                    },
                    {
                        borderColor: 'rgb(255,192,0)',
                    },
                    {
                        borderColor: 'rgb(91,155,213)',
                    },
                    {
                        borderColor: 'rgb(112,173,71)',
                    }
                ]
            },
            {
                baseStyle: {
                    borderWidth: 1,
                    color: 'white'
                },
                shapes: [
                    {
                        backgroundColor: 'rgb(0,0,0)',
                        borderColor: 'rgb(0,0,0)'
                    },
                    {
                        backgroundColor: 'rgb(68,114,196)',
                        borderColor: 'rgb(47,82,143)'
                    },
                    {
                        backgroundColor: 'rgb(237,125,49)',
                        borderColor: 'rgb(174,90,33)'
                    },
                    {
                        backgroundColor: 'rgb(165,165,165)',
                        borderColor: 'rgb(120,120,120)'
                    },
                    {
                        backgroundColor: 'rgb(255,192,0)',
                        borderColor: 'rgb(188,140,0)'
                    },
                    {
                        backgroundColor: 'rgb(91,155,213)',
                        borderColor: 'rgb(65,113,156)'
                    },
                    {
                        backgroundColor: 'rgb(112,173,71)',
                        borderColor: 'rgb(80,126,50)'
                    }
                ]
            },
            {
                baseStyle: {
                    borderColor: 'rgb(255,255,255)',
                    borderWidth: 1.5,
                    color: 'white'
                },
                shapes: [
                    {
                        backgroundColor: 'rgb(0,0,0)',
                    },
                    {
                        backgroundColor: 'rgb(68,114,196)',
                    },
                    {
                        backgroundColor: 'rgb(237,125,49)',
                    },
                    {
                        backgroundColor: 'rgb(165,165,165)',
                    },
                    {
                        backgroundColor: 'rgb(255,192,0)',
                    },
                    {
                        backgroundColor: 'rgb(91,155,213)',
                    },
                    {
                        backgroundColor: 'rgb(112,173,71)',
                    }
                ]
            }
        ],
        connectorShapeStyle: [
            {
                baseStyle: {
                    borderWidth: 0.3,
                    lineStyle: 0,
                },
                shapes: [
                    {
                        borderColor: 'rgb(0,0,0)',
                    },
                    {
                        borderColor: 'rgb(68,114,196)',
                    },
                    {
                        borderColor: 'rgb(237,125,49)',
                    },
                    {
                        borderColor: 'rgb(165,165,165)',
                    },
                    {
                        borderColor: 'rgb(255,192,0)',
                    },
                    {
                        borderColor: 'rgb(91,155,213)',
                    },
                    {
                        borderColor: 'rgb(112,173,71)',
                    }
                ]
            },
            {
                baseStyle: {
                    borderWidth: 0.9,
                    lineStyle: 0,
                },
                shapes: [
                    {
                        borderColor: 'rgb(0,0,0)',
                    },
                    {
                        borderColor: 'rgb(68,114,196)',
                    },
                    {
                        borderColor: 'rgb(237,125,49)',
                    },
                    {
                        borderColor: 'rgb(165,165,165)',
                    },
                    {
                        borderColor: 'rgb(255,192,0)',
                    },
                    {
                        borderColor: 'rgb(91,155,213)',
                    },
                    {
                        borderColor: 'rgb(112,173,71)',
                    }
                ]
            },
            {
                baseStyle: {
                    borderWidth: 1.5,
                    lineStyle: 0,
                },
                shapes: [
                    {
                        borderColor: 'rgb(0,0,0)',
                    },
                    {
                        borderColor: 'rgb(68,114,196)',
                    },
                    {
                        borderColor: 'rgb(237,125,49)',
                    },
                    {
                        borderColor: 'rgb(165,165,165)',
                    },
                    {
                        borderColor: 'rgb(255,192,0)',
                    },
                    {
                        borderColor: 'rgb(91,155,213)',
                    },
                    {
                        borderColor: 'rgb(112,173,71)',
                    }
                ]
            },
            {
                baseStyle: {
                    lineStyle: 'dashed',
                    arrowHeadStyle: 0,
                },
                shapes: [
                    {
                        borderColor: 'rgb(0,0,0)',
                    },
                    {
                        borderColor: 'rgb(68,114,196)',
                    },
                    {
                        borderColor: 'rgb(237,125,49)',
                    },
                    {
                        borderColor: 'rgb(165,165,165)',
                    },
                    {
                        borderColor: 'rgb(255,192,0)',
                    },
                    {
                        borderColor: 'rgb(91,155,213)',
                    },
                    {
                        borderColor: 'rgb(112,173,71)',
                    }
                ]
            },
            {
                baseStyle: {
                    Arrow: "end",
                    lineStyle: 0,
                    arrowHeadStyle: 5,
                    width: 1,
                    length: 1
                },
                shapes: [
                    {
                        borderColor: 'rgb(0,0,0)',
                    },
                    {
                        borderColor: 'rgb(68,114,196)',
                    },
                    {
                        borderColor: 'rgb(237,125,49)',
                    },
                    {
                        borderColor: 'rgb(165,165,165)',
                    },
                    {
                        borderColor: 'rgb(255,192,0)',
                    },
                    {
                        borderColor: 'rgb(91,155,213)',
                    },
                    {
                        borderColor: 'rgb(112,173,71)',
                    }
                ]
            },
            {
                baseStyle: {
                    Arrow: 'beginend',
                    lineStyle: 0,
                    arrowHeadStyle: 5,
                    width: 1,
                    length: 1
                },
                shapes: [
                    {
                        borderColor: 'rgb(0,0,0)',
                    },
                    {
                        borderColor: 'rgb(68,114,196)',
                    },
                    {
                        borderColor: 'rgb(237,125,49)',
                    },
                    {
                        borderColor: 'rgb(165,165,165)',
                    },
                    {
                        borderColor: 'rgb(255,192,0)',
                    },
                    {
                        borderColor: 'rgb(91,155,213)',
                    },
                    {
                        borderColor: 'rgb(112,173,71)',
                    }
                ]
            }
        ],
        colorCompar: {
            'rgb(0,0,0)': 'black',
            'rgb(68,114,196)': 'blue',
            'rgb(237,125,49)': 'orange',
            'rgb(165,165,165)': 'gray',
            'rgb(255,192,0)': 'yellow',
            'rgb(91,155,213)': 'shadowblue',
            'rgb(112,173,71)': 'green'
        }
    }
})();